#include "sim900a.h"
#include "usart.h"		
#include "delay.h"	
#include "led.h"   	 
#include "key.h"	 	 	 	 	 
#include "lcd.h" 
#include "dma.h" 	  
#include "flash.h" 	 
#include "touch.h" 	 
#include "malloc.h"
#include "string.h"    
#include "text.h"		
#include "usart2.h" 
#include "ff.h"
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK STM32
//ATK-SIM900A GSM/GPRSģ	  
//ԭ@ALIENTEK
//̳:www.openedv.com
//޸:2014/4/2
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2009-2019
//All rights reserved	
//********************************************************************************
//
//////////////////////////////////////////////////////////////////////////////////	
 
/////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//usmartֲ֧ 
//յATָӦݷظԴ
//mode:0,USART2_RX_STA;
//     1,USART2_RX_STA;
void sim_at_response(u8 mode)
{
	if(USART2_RX_STA&0X8000)		//յһ
	{ 
		USART2_RX_BUF[USART2_RX_STA&0X7FFF]=0;//ӽ
		printf("%s",USART2_RX_BUF);	//͵
		if(mode)USART2_RX_STA=0;
	} 
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//ATK-SIM900A (ŲԡŲԡGPRS)ô

//sim900a,յӦ
//str:ڴӦ
//ֵ:0,ûеõڴӦ
//    ,ڴӦλ(strλ)
u8* sim900a_check_cmd(u8 *str)
{
	char *strx=0;
	if(USART2_RX_STA&0X8000)		//յһ
	{ 
		USART2_RX_BUF[USART2_RX_STA&0X7FFF]=0;//ӽ
		strx=strstr((const char*)USART2_RX_BUF,(const char*)str);
	} 
	return (u8*)strx;
}
//sim900a
//cmd:͵ַ(Ҫӻس),cmd<0XFFʱ,(緢0X1A),ڵʱַ.
//ack:ڴӦ,Ϊ,ʾҪȴӦ
//waittime:ȴʱ(λ:10ms)
//ֵ:0,ͳɹ(õڴӦ)
//       1,ʧ
u8 sim900a_send_cmd(u8 *cmd,u8 *ack,u16 waittime)
{
	u8 res=0; 
	USART2_RX_STA=0;
	if((u32)cmd<=0XFF)
	{
		while(DMA1_Channel7->CNDTR!=0);	//ȴͨ7   
		USART2->DR=(u32)cmd;
	}else u2_printf("%s\r\n",cmd);//
	if(ack&&waittime)		//ҪȴӦ
	{
		while(--waittime)	//ȴʱ
		{
			delay_ms(10);
			if(USART2_RX_STA&0X8000)//յڴӦ
			{
				if(sim900a_check_cmd(ack))break;//õЧ 
				USART2_RX_STA=0;
			} 
		}
		if(waittime==0)res=1; 
	}
	return res;
} 
//1ַתΪ16
//chr:ַ,0~9/A~F/a~F
//ֵ:chrӦ16ֵ
u8 sim900a_chr2hex(u8 chr)
{
	if(chr>='0'&&chr<='9')return chr-'0';
	if(chr>='A'&&chr<='F')return (chr-'A'+10);
	if(chr>='a'&&chr<='f')return (chr-'a'+10); 
	return 0;
}
//116תΪַ
//hex:16,0~15;
//ֵ:ַ
u8 sim900a_hex2chr(u8 hex)
{
	if(hex<=9)return hex+'0';
	if(hex>=10&&hex<=15)return (hex-10+'A'); 
	return '0';
}
//unicode gbk ת
//src:ַ
//dst:(uni2gbkʱΪgbk,gbk2uniʱ,Ϊunicodeַ)
//mode:0,unicodegbkת;
//     1,gbkunicodeת;
void sim900a_unigbk_exchange(u8 *src,u8 *dst,u8 mode)
{
	u16 temp; 
	u8 buf[2];
	if(mode)//gbk 2 unicode
	{
		while(*src!=0)
		{
			if(*src<0X81)	//Ǻ
			{
				temp=(u16)ff_convert((WCHAR)*src,1);
				src++;
			}else 			//,ռ2ֽ
			{
				buf[1]=*src++;
				buf[0]=*src++; 
				temp=(u16)ff_convert((WCHAR)*(u16*)buf,1); 
			}
			*dst++=sim900a_hex2chr((temp>>12)&0X0F);
			*dst++=sim900a_hex2chr((temp>>8)&0X0F);
			*dst++=sim900a_hex2chr((temp>>4)&0X0F);
			*dst++=sim900a_hex2chr(temp&0X0F);
		}
	}else	//unicode 2 gbk
	{ 
		while(*src!=0)
		{
			buf[1]=sim900a_chr2hex(*src++)*16;
			buf[1]+=sim900a_chr2hex(*src++);
			buf[0]=sim900a_chr2hex(*src++)*16;
			buf[0]+=sim900a_chr2hex(*src++);
 			temp=(u16)ff_convert((WCHAR)*(u16*)buf,0);
			if(temp<0X80){*dst=temp;dst++;}
			else {*(u16*)dst=swap16(temp);dst+=2;}
		} 
	}
	*dst=0;//ӽ
} 
void sim900a_init(void)
{
    delay_ms(10);
    if(sim900a_send_cmd("AT\r\n","OK",100)==0)//ǷӦATָ ĬǻԣԷصAT OK
    {      
      if(sim900a_send_cmd("ATE0\r\n","OK",100)==0)//    
      {
        if(sim900a_send_cmd("AT+CSCS=\"GSM\"\r\n","OK",100)==0)// GSMַ
          {              
              sim900a_send_cmd("AT+CMGF=1\r\n","OK",100);//ıģʽ       
              sim900a_send_cmd("AT+CNMI=2,1\r\n","OK",100);//Ϣʾ
          }
      }
    }
	}

//Զŷ(70[UCS2ʱ,1ַ/ֶ1])
//SIM900AŲ 
void sim900a_sms_send_test(void)
{
  u8 *p="Congratulations! You succeed!";  
  sim900a_init();		
	//Ҫsim900a_unigbk_exchange
  if(sim900a_send_cmd("AT+CMGS=\"15151807607\"\r\n",">",200)==0);//Ҫ͵ֻ
  {
		delay_ms(500);
    if(sim900a_check_cmd(">"))//Ƿյ">"
    {
			LED1=!LED1;
      u2_printf((char*)p);                              //ϢݵGSMģ
      if(sim900a_send_cmd((u8*)0X1A,"+CMGS:",1000)==0)//ͽȴ(ȴ10,Ϊų˵Ļȴʱ᳤Щ)
      {        
			  	LED1=!LED1;				
      }
			
      USART2_RX_STA=0;
    }
  }
}
//sim900aŲ
//ڶŻ߷
//ֵ:0,
//    ,
u8 sim900a_sms_test(void)
{
	u8 key;
	u8 timex=0;
	if(sim900a_send_cmd("AT+CMGF=1","OK",200))return 1;			//ıģʽ 
	if(sim900a_send_cmd("AT+CSCS=\"UCS2\"","OK",200))return 2;	//TEַΪUCS2 
	if(sim900a_send_cmd("AT+CSMP=17,0,2,25","OK",200))return 3;	//öϢıģʽ 
	//sim900a_sms_ui(40,30);
	while(1)
	{
		key=KEY_Scan(0);
		 if(key==KEY0_PRES)
		{ 
			sim900a_sms_send_test();		
		}
		else if(key==KEY1_PRES)break;
		timex++;
		if(timex==20)
		{
			timex=0;
			LED0=!LED0;
		}
		delay_ms(10);
		sim_at_response(1);										//GSMģ鷢͹,ʱϴ
	} 
	sim900a_send_cmd("AT+CSCS=\"GSM\"","OK",200);				//ĬϵGSM 7λȱʡַ
	return 0;
} 












