#include "fontupd.h"
#include "ff.h"	  
#include "flash.h"   
#include "lcd.h"  
#include "malloc.h"
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK MiniSTM32
//ֿ 	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//޸:2014/3/14
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2009-2019
//All rights reserved									  
//////////////////////////////////////////////////////////////////////////////////

//ֿʼַ
#define FONTINFOADDR 	(4916+100)*1024 				//MiniSTM32Ǵ4.8M+100Kַʼ

//ֿϢṹ. 
//ֿϢַС
_font_info ftinfo;

//ֿsdе·
const u8 *GBK24_PATH="0:/SYSTEM/FONT/GBK24.FON";		//GBK24Ĵλ
const u8 *GBK16_PATH="0:/SYSTEM/FONT/GBK16.FON";		//GBK16Ĵλ
const u8 *GBK12_PATH="0:/SYSTEM/FONT/GBK12.FON";		//GBK12Ĵλ
const u8 *UNIGBK_PATH="0:/SYSTEM/FONT/UNIGBK.BIN";		//UNIGBK.BINĴλ


//ʾǰ½
//x,y:
//size:С
//fsize:ļС
//pos:ǰļָλ
u32 fupd_prog(u16 x,u16 y,u8 size,u32 fsize,u32 pos)
{
	float prog;
	u8 t=0XFF;
	prog=(float)pos/fsize;
	prog*=100;
	if(t!=prog)
	{
		LCD_ShowString(x+3*size/2,y,240,320,size,"%");		
		t=prog;
		if(t>100)t=100;
		LCD_ShowNum(x,y,t,3,size);//ʾֵ
	}
	return 0;					    
} 
//ĳһ
//x,y:
//size:С
//fxpath:·
//fx:µ 0,ungbk;1,gbk12;2,gbk16;3,gbk24;
//ֵ:0,ɹ;,ʧ.
u8 updata_fontx(u16 x,u16 y,u8 size,u8 *fxpath,u8 fx)
{
	u32 flashaddr=0;								    
	FIL * fftemp;
	u8 *tempbuf;
 	u8 res;	
	u16 bread;
	u32 offx=0;
	u8 rval=0;	     
	fftemp=(FIL*)mymalloc(sizeof(FIL));	//ڴ	
	if(fftemp==NULL)rval=1;
	tempbuf=mymalloc(4096);	//4096ֽڿռ
	if(tempbuf==NULL)rval=1;
 	res=f_open(fftemp,(const TCHAR*)fxpath,FA_READ); 
 	if(res)rval=2;//ļʧ  
 	if(rval==0)	 
	{
		switch(fx)
		{
			case 0:												//UNIGBK.BIN
				ftinfo.ugbkaddr=FONTINFOADDR+sizeof(ftinfo);	//Ϣͷ֮󣬽UNIGBKת
				ftinfo.ugbksize=fftemp->fsize;					//UNIGBKС
				flashaddr=ftinfo.ugbkaddr;
				break;
			case 1:
				ftinfo.f12addr=ftinfo.ugbkaddr+ftinfo.ugbksize;	//UNIGBK֮󣬽GBK12ֿ
				ftinfo.gbk12size=fftemp->fsize;					//GBK12ֿС
				flashaddr=ftinfo.f12addr;						//GBK12ʼַ
				break;
			case 2:
				ftinfo.f16addr=ftinfo.f12addr+ftinfo.gbk12size;	//GBK12֮󣬽GBK16ֿ
				ftinfo.gbk16size=fftemp->fsize;					//GBK16ֿС
				flashaddr=ftinfo.f16addr;						//GBK16ʼַ
				break;
			case 3:
				ftinfo.f24addr=ftinfo.f16addr+ftinfo.gbk16size;	//GBK16֮󣬽GBK24ֿ
				ftinfo.gkb24size=fftemp->fsize;					//GBK24ֿС
				flashaddr=ftinfo.f24addr;						//GBK24ʼַ
				break;
		}   
		while(res==FR_OK)//ѭִ
		{
	 		res=f_read(fftemp,tempbuf,4096,(UINT *)&bread);		//ȡ	 
			if(res!=FR_OK)break;								//ִд
			SPI_Flash_Write(tempbuf,offx+flashaddr,4096);		//0ʼд4096  
	  		offx+=bread;	  
			fupd_prog(x,y,size,fftemp->fsize,offx);	 			//ʾ
			if(bread!=4096)break;								//.
	 	} 	
		f_close(fftemp);		
	}			 
	myfree(fftemp);	//ͷڴ
	myfree(tempbuf);	//ͷڴ
	return res;
}

//ļ,UNIGBK,GBK12,GBK16,GBK24һ
//x,y:ʾϢʾַ
//size:С
//ʾϢС										  
//ֵ:0,³ɹ;
//		 ,.	  
u8 update_font(u16 x,u16 y,u8 size)
{	
	u8 *gbk24_path=(u8*)GBK24_PATH;
	u8 *gbk16_path=(u8*)GBK16_PATH;
	u8 *gbk12_path=(u8*)GBK12_PATH;
	u8 *unigbk_path=(u8*)UNIGBK_PATH;
	u8 res;		   
 	res=0XFF;		
	ftinfo.fontok=0XFF;
  	SPI_Flash_Write((u8*)&ftinfo,FONTINFOADDR,sizeof(ftinfo));	//֮ǰֿɹı־.ֹµһ,µֿⲿݶʧ.
 	SPI_Flash_Read((u8*)&ftinfo,FONTINFOADDR,sizeof(ftinfo));	//¶ftinfoṹ
 	LCD_ShowString(x,y,240,320,size,"Updating UNIGBK.BIN");		
	res=updata_fontx(x+20*size/2,y,size,unigbk_path,0);			//UNIGBK.BIN
	if(res)return 1;
 	LCD_ShowString(x,y,240,320,size,"Updating GBK12.BIN  ");
	res=updata_fontx(x+20*size/2,y,size,gbk12_path,1);			//GBK12.FON
	if(res)return 2;
	LCD_ShowString(x,y,240,320,size,"Updating GBK16.BIN  ");
	res=updata_fontx(x+20*size/2,y,size,gbk16_path,2);			//GBK16.FON
	if(res)return 3;
	LCD_ShowString(x,y,240,320,size,"Updating GBK24.BIN  ");
	res=updata_fontx(x+20*size/2,y,size,gbk24_path,3);			//GBK24.FON
	if(res)return 4;	   
	//ȫº
	ftinfo.fontok=0XAA;
  	SPI_Flash_Write((u8*)&ftinfo,FONTINFOADDR,sizeof(ftinfo));	//ֿϢ
	return 0;//޴.		 
} 
//ʼ
//ֵ:0,ֿ.
//		 ,ֿⶪʧ
u8 font_init(void)
{			  												 
	SPI_Flash_Init();  
 	SPI_Flash_Read((u8*)&ftinfo,FONTINFOADDR,sizeof(ftinfo));//ftinfoṹ
	if(ftinfo.fontok!=0XAA)return 1;			//ֿ. 
	return 0;		    
}





























