#include "sys.h" 
#include "fontupd.h"
#include "flash.h"
#include "lcd.h"
#include "text.h"	
#include "string.h"												   
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK MiniSTM32
//ʾ 	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//޸:2014/3/14
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2009-2019
//All rights reserved									  
//////////////////////////////////////////////////////////////////////////////////
						            
//code ַָ뿪ʼ
//ֿвҳģ
//code ַĿʼַ,GBK
//mat  ݴŵַ (size/8+((size%8)?1:0))*(size) bytesС	
//size:С
void Get_HzMat(unsigned char *code,unsigned char *mat,u8 size)
{		    
	unsigned char qh,ql;
	unsigned char i;					  
	unsigned long foffset; 
	u8 csize=(size/8+((size%8)?1:0))*(size);//õһַӦռֽ	 
	qh=*code;
	ql=*(++code);
	if(qh<0x81||ql<0x40||ql==0xff||qh==0xff)// ú
	{   		    
	    for(i=0;i<csize;i++)*mat++=0x00;//
	    return; //
	}          
	if(ql<0x7f)ql-=0x40;//ע!
	else ql-=0x41;
	qh-=0x81;   
	foffset=((unsigned long)190*qh+ql)*csize;	//õֿеֽƫ  		  
	switch(size)
	{
		case 12:
			SPI_Flash_Read(mat,foffset+ftinfo.f12addr,24);
			break;
		case 16:
			SPI_Flash_Read(mat,foffset+ftinfo.f16addr,32);
			break;
		case 24:
			SPI_Flash_Read(mat,foffset+ftinfo.f24addr,72);
			break;
			
	}     												    
}  
//ʾһָСĺ
//x,y :ֵ
//font:GBK
//size:С
//mode:0,ʾ,1,ʾ	   
void Show_Font(u16 x,u16 y,u8 *font,u8 size,u8 mode)
{
	u8 temp,t,t1;
	u16 y0=y;
	u8 dzk[72];   
	u8 csize=(size/8+((size%8)?1:0))*(size);//õһַӦռֽ	 
	if(size!=12&&size!=16&&size!=24)return;	//ֵ֧size
	Get_HzMat(font,dzk,size);	//õӦСĵ 
	for(t=0;t<csize;t++)
	{   												   
		temp=dzk[t];			//õ                          
		for(t1=0;t1<8;t1++)
		{
			if(temp&0x80)LCD_Fast_DrawPoint(x,y,POINT_COLOR);
			else if(mode==0)LCD_Fast_DrawPoint(x,y,BACK_COLOR); 
			temp<<=1;
			y++;
			if((y-y0)==size)
			{
				y=y0;
				x++;
				break;
			}
		}  	 
	}  
}
//ָλÿʼʾһַ	    
//֧Զ
//(x,y):ʼ
//width,height:
//str  :ַ
//size :С
//mode:0,ǵӷʽ;1,ӷʽ    	   		   
void Show_Str(u16 x,u16 y,u16 width,u16 height,u8*str,u8 size,u8 mode)
{					
	u16 x0=x;
	u16 y0=y;							  	  
    u8 bHz=0;     //ַ  	    				    				  	  
    while(*str!=0)//δ
    { 
        if(!bHz)
        {
	        if(*str>0x80)bHz=1;// 
	        else              //ַ
	        {      
                if(x>(x0+width-size/2))//
				{				   
					y+=size;
					x=x0;	   
				}							    
		        if(y>(y0+height-size))break;//Խ緵      
		        if(*str==13)//з
		        {         
		            y+=size;
					x=x0;
		            str++; 
		        }  
		        else LCD_ShowChar(x,y,*str,size,mode);//Чд 
				str++; 
		        x+=size/2; //ַ,Ϊȫֵһ 
	        }
        }else// 
        {     
            bHz=0;//кֿ    
            if(x>(x0+width-size))//
			{	    
				y+=size;
				x=x0;		  
			}
	        if(y>(y0+height-size))break;//Խ緵  						     
	        Show_Font(x,y,str,size,mode); //ʾ,ʾ 
	        str+=2; 
	        x+=size;//һƫ	    
        }						 
    }   
}  			 		 
//ָȵмʾַ
//ַȳlen,Show_Strʾ
//len:ָҪʾĿ			  
void Show_Str_Mid(u16 x,u16 y,u8*str,u8 size,u8 len)
{
	u16 strlenth=0;
   	strlenth=strlen((const char*)str);
	strlenth*=size/2;
	if(strlenth>len)Show_Str(x,y,lcddev.width,lcddev.height,str,size,1);
	else
	{
		strlenth=(len-strlenth)/2;
	    Show_Str(strlenth+x,y,lcddev.width,lcddev.height,str,size,1);
	}
}   

























		  






